'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapComponentProps = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var KEY = 0;
var VALUE = 1;

var mapComponentProps = exports.mapComponentProps = function mapComponentProps() {
  var componentProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var ignoreList = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return Object.entries(componentProps).reduce(function (newProps, wrappedComponentProp) {
    // see https://github.com/eslint/eslint/issues/8581
    newProps[wrappedComponentProp[KEY]] = // eslint-disable-line no-param-reassign
    _immutable.Iterable.isIterable(wrappedComponentProp[VALUE]) && !Array.prototype.includes.call(ignoreList, wrappedComponentProp[KEY]) ? wrappedComponentProp[VALUE].toJS() : wrappedComponentProp[VALUE];
    return newProps;
  }, {});
};

exports.default = function (WrappedComponent) {
  var ignoreList = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return function (wrappedComponentProps) {
    var propsJS = mapComponentProps(wrappedComponentProps, ignoreList);

    return _react2.default.createElement(WrappedComponent, propsJS);
  };
};